package com.bluetoothprinter_sp300.util;

import java.util.Hashtable;

import android.graphics.Bitmap;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.EncodeHintType;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.WriterException;
import com.google.zxing.common.BitMatrix;
import com.google.zxing.qrcode.QRCodeWriter;
public class DimenCodeImageUtils {
	
	/**
	 * 生成一维码
	 * @param codeValue 一维码类型
	 * @param width 一维码的宽
	 * @param height 一维码的高
	 * @return
	 */
	public static Bitmap createOneDimenCodeImage(String codeValue, int width, int height,String type) {
		System.out.println("传过来的宽高:"+width+":"+height);
		if (width == 0 || height == 0) {
			width =400;   
			height =180;
		}
		BarcodeFormat barcodeFormat=BarcodeFormat.CODE_128;
		
		if(type.equals("CODE_128"))
		{
			barcodeFormat=BarcodeFormat.CODE_128;
		}
		else if(type.equals("CODE_39"))
		{
			barcodeFormat=BarcodeFormat.CODE_39;
		}
		
		else if(type.equals("EAN_13"))
		{
			barcodeFormat=BarcodeFormat.EAN_13;
		}
		else if(type.equals("EAN_8"))
		{
			barcodeFormat=BarcodeFormat.EAN_8;
		}
		else if(type.equals("PDF_417"))
		{
			barcodeFormat=BarcodeFormat.PDF_417;
		}
	   
	    else if(type.equals("ITF"))
	    {
	    	barcodeFormat=BarcodeFormat.ITF;
		}
		Bitmap bitmap = null;
		try {
			Hashtable<EncodeHintType, String> hints = new Hashtable<EncodeHintType, String>();
			hints.put(EncodeHintType.CHARACTER_SET, "utf-8");
			BitMatrix bitMatrix = new MultiFormatWriter().encode(codeValue,
					barcodeFormat, width, height, hints);
			System.out.println("实际的宽高:"+width+":"+height);
			int[] pixels = new int[width * height];
			for (int y = 0; y < height; y++) {
				for (int x = 0; x < width; x++) {
					if (bitMatrix.get(x, y)) {
						pixels[y * width + x] = 0xff000000;
					}
				}
			}
			 bitmap = Bitmap.createBitmap(width, height,
						Bitmap.Config.ARGB_8888);
			bitmap.setPixels(pixels, 0, width, 0, 0, width, height);
		} catch (WriterException e) {
			e.printStackTrace();
		}

		return bitmap;
	}
	
	/**
	 * 生成二维码
	 * @param codeValue 二维码的文字
	 * @param width 二维码的宽
	 * @param height 二维码的高
	 * @return
	 */
	public static Bitmap createTwoDimenCodeImage(String codeValue, int width, int height) {
		System.out.println("传过来的宽高:"+width+":"+height);
		if (width == 0 || height == 0) {
			width = 250;
			height = 250;
		}
		Bitmap bitmap = null;

		try {
			Hashtable<EncodeHintType, Object> hints = new Hashtable<EncodeHintType, Object>();
			hints.put(EncodeHintType.CHARACTER_SET, "utf-8");
			//hints.put(EncodeHintType.MARGIN, 0);
			
			BitMatrix bitMatrix = new QRCodeWriter().encode(codeValue,
					BarcodeFormat.QR_CODE, width, height, hints);
			int[] rec = bitMatrix.getEnclosingRectangle();  
			int resWidth = rec[2] + 1;  
			int resHeight = rec[3] + 1;  
			BitMatrix resMatrix = new BitMatrix(resWidth, resHeight);  
			resMatrix.clear();  
			for (int i = 0; i < resWidth; i++) {  
			    for (int j = 0; j < resHeight; j++) {  
			        if (bitMatrix.get(i + rec[0], j + rec[1])) { 
			             resMatrix.set(i, j); 
			        } 
			    }  
			}  
			width=resMatrix.getWidth();
			height=resMatrix.getHeight();
			System.out.println("实际的宽高:"+width+":"+height);
			int[] pixels = new int[width * height];
			for (int y = 0; y < height; y++) {
				for (int x = 0; x < width; x++) {
					if (resMatrix.get(x, y)) {
						pixels[y * width + x] = 0xff000000;
					} else {
						pixels[y * width + x] = 0xffffffff;
					}

				}
			}
			 bitmap = Bitmap.createBitmap(width, height,
					Bitmap.Config.ARGB_8888);
			bitmap.setPixels(pixels, 0, width, 0, 0, width, height);
		} catch (WriterException e) {
			e.printStackTrace();
		}

		return bitmap;
	}
}
